"use strict";

var _react = _interopRequireDefault(require("react"));

var _enzyme = require("enzyme");

var _index = require("../index.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*
Copyright (c) 2018 Uber Technologies, Inc.

This source code is licensed under the MIT license found in the
LICENSE file in the root directory of this source tree.
*/
describe('Avatar styled components', function () {
  var styledComponents = [[_index.StyledAvatar, 'StyledAvatar'], [_index.StyledRoot, 'StyledRoot']];
  test.each(styledComponents)('default properties', function (Component, name) {
    var component = (0, _enzyme.shallow)(_react.default.createElement(Component, null));
    expect(component.instance().getStyles()).toMatchSnapshot("".concat(name, " has expected default styles"));
  });
  test.each(styledComponents)('non-default size', function (Component, name) {
    var component = (0, _enzyme.shallow)(_react.default.createElement(Component, {
      $size: "scale1200"
    }));
    expect(component.instance().getStyles()).toMatchSnapshot("".concat(name, " has expected styles with non-default size"));
  });
  it('StyledRoot failure state', function () {
    var component = (0, _enzyme.shallow)(_react.default.createElement(_index.StyledRoot, {
      $didImageFailToLoad: true
    }));
    expect(component.instance().getStyles()).toMatchSnapshot('StyledRoot has expected failure state styles');
  });
});