var _examples$ACCORDION_E;

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/*
Copyright (c) 2018 Uber Technologies, Inc.

This source code is licensed under the MIT license found in the
LICENSE file in the root directory of this source tree.
*/
import * as React from 'react';
import { styled } from '../styles/index.js';
import { Accordion, Panel, StatefulPanel } from './index.js';
import examples from './examples-list.js';
export var suite = 'Component Test Suite';
var Centered = styled('div', {
  position: 'relative',
  display: 'flex',
  flexDirection: 'row',
  justifyContent: 'center',
  alignItems: 'start',
  height: '90vh',
  lineHeight: 1.5,
  width: '500px',
  margin: '0 auto'
});
Centered.displayName = "Centered";
var panelOverrides = {
  Header: {
    props: {
      'data-title': 'data-title'
    },
    style: {
      borderBottom: '1px solid #916cb2',
      color: '#4f1e7b'
    }
  },
  Content: {
    style: function style(_ref) {
      var $expanded = _ref.$expanded;
      return {
        backgroundColor: '#efe6f7',
        borderBottom: $expanded ? '1px solid #916cb2' : 'none'
      };
    }
  },
  ToggleIcon: {
    props: {
      title: 'Toggle expandable block',
      'data-label': 'toggle'
    },
    style: {
      backgroundColor: '#916cb2',
      color: '#fff',
      borderRadius: '50%',
      paddingTop: '5px',
      paddingBottom: '5px',
      paddingLeft: '5px',
      paddingRight: '5px'
    }
  }
};
var content = 'Praesent condimentum ante ac ipsum aliquam, ac scelerisque velit sagittis. Ut sit amet libero scelerisque, accumsan ante vitae, hendrerit tellus. Nullam metus est, vehicula a aliquet id, lobortis in mauris.';
export default (_examples$ACCORDION_E = {}, _defineProperty(_examples$ACCORDION_E, examples.ACCORDION_EXAMPLE, function Story1() {
  return React.createElement(Centered, null, React.createElement(Accordion, null, React.createElement(Panel, {
    title: "Accordion panel 1"
  }, content), React.createElement(Panel, {
    title: "Accordion panel 2"
  }, content), React.createElement(Panel, {
    title: "Accordion panel 3"
  }, content)));
}), _defineProperty(_examples$ACCORDION_E, examples.STYLE_PROPS_OVERRIDES, function Story2() {
  return React.createElement(Centered, null, React.createElement(Accordion, {
    initialState: {
      expanded: ['panel-1']
    }
  }, React.createElement(Panel, {
    key: "panel-1",
    title: "Accordion panel 1",
    overrides: panelOverrides
  }, content), React.createElement(Panel, {
    title: "Accordion panel 2",
    overrides: panelOverrides
  }, content), React.createElement(Panel, {
    disabled: true,
    title: "Accordion panel 3",
    overrides: panelOverrides
  }, content)));
}), _defineProperty(_examples$ACCORDION_E, examples.SINGLE_STATEFUL_PANEL, function Story3() {
  return React.createElement(Centered, null, React.createElement(StatefulPanel, {
    title: "Expandable panel"
  }, content));
}), _examples$ACCORDION_E);