var _examples$FILE_UPLOAD;

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/*
Copyright (c) 2018 Uber Technologies, Inc.

This source code is licensed under the MIT license found in the
LICENSE file in the root directory of this source tree.
*/

/* eslint-disable no-console */
import * as React from 'react';
import { Unstable_FileUploader } from './index.js';
import examples from './examples-list.js';
export default (_examples$FILE_UPLOAD = {}, _defineProperty(_examples$FILE_UPLOAD, examples.FILE_UPLOADER_EXAMPLE, function FileUploaderBasic() {
  return React.createElement(React.Fragment, null, React.createElement(Unstable_FileUploader, null), React.createElement("br", null), React.createElement(Unstable_FileUploader, {
    progressAmount: 40,
    progressMessage: "Uploading... 8.24 of 45.08MB",
    onCancel: function onCancel() {
      return console.log('cancel');
    },
    onRetry: function onRetry() {
      return console.log('retry');
    }
  }), React.createElement("br", null), React.createElement(Unstable_FileUploader, {
    progressAmount: 40,
    progressMessage: "Uploading... 8.24 of 45.08MB",
    errorMessage: "Upload failed... connection was lost.",
    onCancel: function onCancel() {
      return console.log('cancel');
    },
    onRetry: function onRetry() {
      return console.log('retry');
    }
  }));
}), _defineProperty(_examples$FILE_UPLOAD, examples.FILE_UPLOADER_ACCEPT, function FileUploaderAccept() {
  return React.createElement(Unstable_FileUploader, {
    accept: ".jpeg"
  });
}), _defineProperty(_examples$FILE_UPLOAD, examples.FILE_UPLOADER_DISABLED, function FileUploaderDisabled() {
  return React.createElement(Unstable_FileUploader, {
    disabled: true
  });
}), _defineProperty(_examples$FILE_UPLOAD, examples.FILE_UPLOADER_OVERRIDES, function FileUploaderOverrides() {
  return React.createElement(Unstable_FileUploader, {
    overrides: {
      FileDragAndDrop: {
        style: function style(props) {
          return {
            borderColor: props.$isDragActive ? props.$theme.colors.positive : props.$theme.colors.warning
          };
        }
      },
      ContentMessage: {
        style: function style(props) {
          return {
            color: props.$theme.colors.warning
          };
        }
      },
      ContentSeparator: {
        style: function style(props) {
          return {
            color: props.$theme.colors.warning
          };
        }
      }
    }
  });
}), _examples$FILE_UPLOAD);