var _examples$STATEFUL_PA;

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/*
Copyright (c) 2018 Uber Technologies, Inc.

This source code is licensed under the MIT license found in the
LICENSE file in the root directory of this source tree.
*/
import * as React from 'react';
import StatefulPagination from './stateful-pagination.js';
import Pagination from './pagination.js';
import { KIND } from '../button/index.js';
export var suite = 'Pagination Test Suite';
import examples from './examples-list.js';
export default (_examples$STATEFUL_PA = {}, _defineProperty(_examples$STATEFUL_PA, examples.STATEFUL_PAGINATION, function Story1() {
  return React.createElement(StatefulPagination, {
    overrides: {
      NextButton: {
        props: {
          'data-test': 'next-button'
        }
      },
      PrevButton: {
        props: {
          'data-test': 'prev-button'
        }
      },
      DropdownButton: {
        props: {
          'data-test': 'dropdown-button'
        }
      }
    },
    numPages: 10
  });
}), _defineProperty(_examples$STATEFUL_PA, examples.STATELESS_PAGINATION, function Story2() {
  return React.createElement(Pagination, {
    numPages: 18,
    currentPage: 4
  });
}), _defineProperty(_examples$STATEFUL_PA, examples.PAGINATION_OVERRIDE, function Story2() {
  return React.createElement(StatefulPagination, {
    numPages: 10,
    labels: {
      prevButton: 'Back',
      nextButton: 'Forward',
      preposition: 'out of'
    },
    overrides: {
      NextButton: {
        props: {
          kind: KIND.secondary
        }
      },
      PrevButton: {
        props: {
          kind: KIND.secondary
        }
      },
      DropdownMenu: {
        style: {
          top: '100px'
        }
      }
    }
  });
}), _examples$STATEFUL_PA);