var _tests$SIMPLE_EXAMPLE;

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/*
Copyright (c) 2018 Uber Technologies, Inc.

This source code is licensed under the MIT license found in the
LICENSE file in the root directory of this source tree.
*/
import * as React from 'react';
import { styled } from '../styles/index.js';
import { Spinner } from './index.js';
export var suite = 'Spinner Test Suite';
export var tests = {
  SIMPLE_EXAMPLE: 'Spinner component',
  STYLE_PROPS_OVERRIDES: 'Spinner style and props overrides'
};
var Centered = styled('div', {
  position: 'relative',
  display: 'flex',
  flexDirection: 'row',
  justifyContent: 'center',
  alignItems: 'center',
  height: '90vh',
  lineHeight: 1.5
});
Centered.displayName = "Centered";
var Spacing = styled('span', {
  margin: '10px'
});
Spacing.displayName = "Spacing";
export default (_tests$SIMPLE_EXAMPLE = {}, _defineProperty(_tests$SIMPLE_EXAMPLE, tests.SIMPLE_EXAMPLE, function Story1() {
  return React.createElement(Centered, null, React.createElement(Spacing, null, React.createElement(Spinner, {
    size: 22
  })), React.createElement(Spacing, null, React.createElement(Spinner, null)), React.createElement(Spacing, null, React.createElement(Spinner, {
    size: 88
  })));
}), _defineProperty(_tests$SIMPLE_EXAMPLE, tests.STYLE_PROPS_OVERRIDES, function Story3() {
  return React.createElement(Centered, null, React.createElement(Spinner, {
    overrides: {
      Svg: {
        props: {
          'data-label': 'data-label'
        },
        style: function style(_ref) {
          var $theme = _ref.$theme;
          return {
            borderRadius: '50%',
            backgroundColor: $theme.colors.primary50
          };
        }
      }
    }
  }));
}), _tests$SIMPLE_EXAMPLE);