function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

/*
Copyright (c) 2018 Uber Technologies, Inc.

This source code is licensed under the MIT license found in the
LICENSE file in the root directory of this source tree.
*/

/* eslint-env node */

/* eslint-disable flowtype/require-valid-file-annotation */
var scenarios = require('./examples-list');

var _require = require('../../e2e/helpers'),
    getPuppeteerUrl = _require.getPuppeteerUrl,
    analyzeAccessibility = _require.analyzeAccessibility;

var suite = 'Tag Test Suite';
describe(suite, function () {
  beforeAll(
  /*#__PURE__*/
  _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee() {
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return page.goto(getPuppeteerUrl({
              suite: suite,
              test: scenarios.ALL_BASIC_COLORS
            }));

          case 2:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this);
  })));
  it('passes basic a11y tests',
  /*#__PURE__*/
  _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee2() {
    var accessibilityReport;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return analyzeAccessibility(page);

          case 2:
            accessibilityReport = _context2.sent;
            expect(accessibilityReport).toHaveNoAccessibilityIssues();

          case 4:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, this);
  })));
});