"use strict";

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

/*
Copyright (c) 2018 Uber Technologies, Inc.

This source code is licensed under the MIT license found in the
LICENSE file in the root directory of this source tree.
*/

/* eslint-env node */

/* eslint-disable flowtype/require-valid-file-annotation */
var scenarios = require('./examples-list');

var _require = require('../../e2e/helpers'),
    getPuppeteerUrl = _require.getPuppeteerUrl,
    analyzeAccessibility = _require.analyzeAccessibility;

var suite = 'Input Test Suite';
var selectors = {
  input: 'input[data-test="e2e"]'
};
describe(suite, function () {
  beforeAll(
  /*#__PURE__*/
  _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee() {
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return page.goto(getPuppeteerUrl({
              suite: suite,
              test: scenarios.STATE_EXAMPLE
            }));

          case 2:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this);
  })));
  it('passes basic a11y tests',
  /*#__PURE__*/
  _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee2() {
    var accessibilityReport;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return page.waitFor(selectors.input);

          case 2:
            _context2.next = 4;
            return analyzeAccessibility(page, {
              rules: [{
                id: 'label',
                enabled: false
              }]
            });

          case 4:
            accessibilityReport = _context2.sent;
            expect(accessibilityReport).toHaveNoAccessibilityIssues();

          case 6:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, this);
  })));
  it('preset value is displayed',
  /*#__PURE__*/
  _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee3() {
    var value;
    return regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return page.waitFor(selectors.input);

          case 2:
            _context3.next = 4;
            return page.$eval(selectors.input, function (input) {
              return input.value;
            });

          case 4:
            value = _context3.sent;
            expect(value).toBe('uber');

          case 6:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3, this);
  })));
  it('entered value is displayed',
  /*#__PURE__*/
  _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee4() {
    var value;
    return regeneratorRuntime.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            _context4.next = 2;
            return page.waitFor(selectors.input);

          case 2:
            _context4.next = 4;
            return page.keyboard.type('_good');

          case 4:
            _context4.next = 6;
            return page.$eval(selectors.input, function (input) {
              return input.value;
            });

          case 6:
            value = _context4.sent;
            expect(value).toBe('uber_good');

          case 8:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4, this);
  })));
});