"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = Menu;

var React = _interopRequireWildcard(require("react"));

var _styledComponents = require("./styled-components.js");

var _optionList = _interopRequireDefault(require("./option-list.js"));

var _utils = require("./utils.js");

var _overrides = require("../helpers/overrides.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function Menu(_ref) {
  var _ref$getRequiredItemP = _ref.getRequiredItemProps,
      getRequiredItemProps = _ref$getRequiredItemP === void 0 ? function (item, index) {
    return {};
  } : _ref$getRequiredItemP,
      items = _ref.items,
      _ref$overrides = _ref.overrides,
      overrides = _ref$overrides === void 0 ? {} : _ref$overrides,
      _ref$rootRef = _ref.rootRef,
      rootRef = _ref$rootRef === void 0 ? React.createRef() : _ref$rootRef;

  var _getOverrides = (0, _overrides.getOverrides)(overrides.List, _styledComponents.List),
      _getOverrides2 = _slicedToArray(_getOverrides, 2),
      List = _getOverrides2[0],
      listProps = _getOverrides2[1];

  var _getOverrides3 = (0, _overrides.getOverrides)(overrides.Option, _optionList.default),
      _getOverrides4 = _slicedToArray(_getOverrides3, 2),
      Option = _getOverrides4[0],
      optionProps = _getOverrides4[1];

  return React.createElement(List, _extends({
    role: "listbox",
    $ref: rootRef
  }, listProps), items.map(function (item, index) {
    var requiredProps = getRequiredItemProps(item, index);
    return React.createElement(Option, _extends({
      item: item,
      key: index,
      role: "option",
      tabIndex: index === 0 ? 0 : -1 // Allows tab focus into first element

    }, (0, _utils.getSharedProps)(requiredProps), optionProps));
  }));
}